﻿#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

void dfs(int v, int h, vector<bool>& visited, vector<vector<int>>& G, set<int>& def) {
    if (h < 0) return;
    visited[v] = true;
    def.insert(v);
    for (int u : G[v]) {
        if (!visited[u]) {
            dfs(u, h - 1, visited, G, def);
        }
    }
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<int>> G(n + 1);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        G[a].push_back(b);
        G[b].push_back(a);
    }

    vector<pair<int, int>> M(k);
    for (int i = 0; i < k; ++i) {
        cin >> M[i].first >> M[i].second;
    }

    set<int> def;
    for (auto& guard : M) {
        int p = guard.first;
        int h = guard.second;
        vector<bool> visited(n + 1, false);
        dfs(p, h, visited, G, def);
    }

    cout << def.size() << endl;
    for (int v : def) {
        cout << v << " ";
    }
    cout << endl;

    return 0;
}